From ad3b1f9964cf6cfd5f3692e6d11784dba45daf0a Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sat, 9 Dec 2023 18:47:22 +0000
Subject: [PATCH 52/54] fix: hide unavailable clock/voltage rows

---
 .../app/root_stack/oc_page/clocks_frame.rs    | 19 ++++++++++++-------
 1 file changed, 12 insertions(+), 7 deletions(-)

diff --git a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
index d2bf3391..bf9768c2 100644
--- a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
@@ -324,9 +324,13 @@ impl ClocksFrame {
     }
 
     fn set_configuration_mode(&self, advanced: bool) {
-        self.min_sclk_adjustment.2.set_visible(advanced);
-        self.min_mclk_adjustment.2.set_visible(advanced);
-        self.min_voltage_adjustment.2.set_visible(advanced);
+        for (adj, _, w) in [
+            &self.min_sclk_adjustment,
+            &self.min_mclk_adjustment,
+            &self.min_voltage_adjustment,
+        ] {
+            w.set_visible(advanced && adj.upper() > 0.0)
+        }
     }
 }
 
@@ -366,10 +370,11 @@ fn oc_adjustment(title: &'static str, listbox: &ListBox) -> (Adjustment, Rc<Atom
         changed.store(true, Ordering::SeqCst);
     }));
 
-    adjustment.connect_changed(clone!(@strong value_selector => move |adjustment| {
-            value_selector.set_sensitive(adjustment.upper() == 0.0);
-        }
-    ));
+    adjustment.connect_changed(clone!(@strong row => move |adjustment| {
+        let active = adjustment.upper() > 0.0;
+        row.set_visible(active);
+        row.set_sensitive(active);
+    }));
 
     (adjustment, changed, row.upcast::<Widget>())
 }

